#
# AvrX Lib makefile
# Larry Barello
#
# Need an absolute path for the source files in order for Astudio debugging support
# to work in a library.  This needs to be rebuilt if the source location should
# ever change.
#
# In DOS, or your startup file, set AVRX = root directory.
#
# Generic stuff

	DEBUG	= -DSINGLESTEPSUPPORT
	ABSPATH = c:/mydocu~1/robotics/iaravr~1.5/avrx
#	ABSPATH	= $(AVRX)/avrx
	RM	= rm -f
	INCDIR	= .
#
# MCU - What a mess.  IAR uses different mechanisms for C and ASM
# and buggers the identifier for the mega parts so the GCCMCU will break
# with mega parts.  The AVRXMCU goes away when IAR updates their tools for
# unified IO headers (ioavr.h)
#
	MCU	= 8535
	AAVRMCU	= 1
	GCCMCU	= at90s$(MCU)
	AVRXMCU	= __AT90S$(MCU)__
	
# GCC equates
	LIST	= ,-ahlms=$(<:.s=.lst)
	AS	= avr-gcc -x assembler-with-cpp -mmcu=$(GCCMCU) -c -Wa,-gstabs,-mmcu=$(GCCMCU) -I$(INCDIR) $(DEBUG)
	AR	= avr-ar -rcsv

# ICC equates
	AAVR	= aavr -b -re -v$(AAVRMCU) -I$(INCDIR) -I$(IAR)/avr/inc -D$(AVRXMCU) $(DEBUG)
	XLIB	= xlib


	ASRC =  monitor.s \
		serialio.s \
		avrx_tasking.s \
		avrx_semaphores.s \
		avrx_resetsemaphore.s \
		avrx_singlestep.s \
		avrx_terminate.s \
		avrx_halt.s \
		avrx_priority.s \
		avrx_suspend.s \
		avrx_testsemaphore.s \
		avrx_message.s \
		avrx_recvmessage.s \
		avrx_timequeue.s \
		avrx_starttimermessage.s \
		avrx_canceltimer.s \
		avrx_canceltimermessage.s\
		avrx_generatesinglestepinterrupt.s\
		avrx_eeprom.s
	OBJ =	$(ASRC:.s=.o)

%o: %s avrx.inc makefile
	$(AS) $(ABSPATH)/$< -o $@

%r90: %s avrx.inc makefile
	$(AAVR) $< -o $@

all:	iar gcc

iar:	avrx.r90

gcc:	avrx.a

avrx.a:  $(OBJ) makefile
	$(AR) $@ $(OBJ)

avrx.xlb: makefile
	echo define-cpu A90 > avrx.xlb
	for %i in ($(ASRC:.s=.r90) do echo fetch-mod % avrx >> avrx.xlb
	echo fetch-mod avrx_iar_vect avrx >> avrx.xlb
	echo exit >> avrx.xlb
	
avrx.r90: $(ASRC:.s=.r90) avrx_iar_vect.r90 makefile avrx.inc avrx-io.h
	$(RM) avrx.r90
	$(XLIB) avrx.xlb
	
clean:
	$(RM) $(OBJ) $(ASRC:.s=.r90) avrx_iar_vect.r90 avrx.a avrx.r90 $(ASRC:.s=.s_sym)

